<?php
namespace Concrete\Package\VideoPlugin;

use Concrete\Core\Editor\Plugin;
use \Core;
use \AssetList;

class Controller extends \Concrete\Core\Package\Package
{

    protected $pkgHandle = 'video_plugin';
    protected $appVersionRequired = '5.7.4';
    protected $pkgVersion = '0.9';

    public function getPackageDescription()
    {
        return t("Adds videos to the rich text editor.");
    }

    public function getPackageName()
    {
        return t("Insert Video");
    }

    public function on_start()
    {
        $al = AssetList::getInstance();
        $al->register(
            'javascript', 'editor/plugin/video', 'js/redactor/video.js',
                            array(), 'video_plugin'
        );
        $al->register(
            'css', 'editor/plugin/video', 'css/redactor/video.css',
                            array(), 'video_plugin'
        );
        $al->registerGroup('editor/plugin/video', array(
            array('javascript', 'editor/plugin/video'),
            array('css', 'editor/plugin/video')
        ));
        $plugin = new Plugin();
        $plugin->setKey('video');
        $plugin->setName('Insert Video');
        $plugin->requireAsset('editor/plugin/video');

        Core::make('editor')->getPluginManager()->register($plugin);
    }

}