if (!RedactorPlugins) var RedactorPlugins = {};

(function($)
{
	RedactorPlugins.video = function()
	{
		return {
			reUrlYoutube: /https?:\/\/(?:[0-9A-Z-]+\.)?(?:youtu\.be\/|youtube\.com\S*[^\w\-\s])([\w\-]{11})(?=[^\w\-]|$)(?![?=&+%\w.-]*(?:['"][^<>]*>|<\/a>))[?=&+%\w.-]*/ig,
			reUrlVimeo: /https?:\/\/(www\.)?vimeo.com\/(\d+)($|\/)/,
			getTemplate: function()
			{
				return String()
				+ '<section id="redactor-modal-video-insert">'
					+ '<p>' + 'Video Embed Code or Youtube/Vimeo Link' + '</p>'
					+ '<textarea id="redactor-insert-video-area"></textarea>'
					+ '<div class="hw">'
						+ '<p>' + 'Height' + '</p>'
						+ '<div class="input-group">'
							+ '<input type="text" class="form-control" id="redactor-set-height"/><div class="input-group-addon">px</div>'
						+ '</div>'
						+ '</div>'
					+ '</div>'
				+ '</section>';
			},
			init: function()
			{
				var button = this.button.add('video', 'Insert Video');
				this.button.setAwesome('video', 'fa-youtube-play');
				this.button.addCallback(button, this.video.show);
			},
			show: function()
			{
				this.modal.addTemplate('video', this.video.getTemplate());

				this.modal.load('video', 'Insert Video', 550);
				this.modal.createCancelButton();

				var button = this.modal.createActionButton('insert');
				button.on('click', this.video.insert);

				this.selection.save();
				this.modal.show();

				$('#redactor-insert-video-area').focus();

			},
			insert: function()
			{
				var data = $('#redactor-insert-video-area').val();
				var height = $('#redactor-set-height').val();

				data = data.replace(/width="\d+"/i, 'width="100%"');
				heightSet = 'height="' + height + 'px"';
				data = data.replace(/height="\d+"/i, heightSet);

				if (!data.match(/<iframe|<video/gi))
				{
					data = this.clean.stripTags(data);

					// parse if it is link on youtube & vimeo
					var iframeStart = '<iframe style="width: 100%; height: ' + height + 'px;" src="';
					var iframeEnd = '" frameborder="0" allowfullscreen></iframe>';

					if (data.match(this.video.reUrlYoutube))
					{
						data = data.replace(this.video.reUrlYoutube, iframeStart + '//www.youtube.com/embed/$1' + iframeEnd);
					}
					else if (data.match(this.video.reUrlVimeo))
					{
						data = data.replace(this.video.reUrlVimeo, iframeStart + '//player.vimeo.com/video/$2' + iframeEnd);
					}
				}

				this.selection.restore();
				this.modal.close();

				var current = this.selection.getBlock() || this.selection.getCurrent();

				if (current) $(current).after(data);
				else
				{
					this.insert.html(data);
				}

				this.code.sync();
			}
		};
	};
})(jQuery);